package tests;

import entities.CallBackCounts;
import entities.overrideentitylistenerwithemptyxmltag.EntityWithUnusedEntityListener;
import java.util.Map;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

public class TestOverrideEntityListenerWithEmptyXMLTag {
    
    protected EntityManagerFactory emf;
    
    private static final Long ID = 12241l;
    
    public TestOverrideEntityListenerWithEmptyXMLTag() {
    }
    
    public void test() {
        try {
            emf = Persistence.createEntityManagerFactory("empty-tag-bug");
            CallBackCounts.clearCountsMap();
            actionsToInvokeAllCallbackListeners();
            assertCallBackListenersInvokedCorrectly();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    private void actionsToInvokeAllCallbackListeners() {
        persistEntity();
    }
    
    private void persistEntity() {
        EntityManager em = emf.createEntityManager();
        
        EntityWithUnusedEntityListener entity = new EntityWithUnusedEntityListener();
        
        entity.setId(ID);
        entity.setSomeField("SomeValue");
        
        em.getTransaction().begin();
        em.persist(entity);
        em.getTransaction().commit();
    }
    
    private void assertCallBackListenersInvokedCorrectly() {
        assertCountCorrectFor("prePersist", 0);
        assertCountCorrectFor("postPersist", 0);
    }
    
    private void assertCountCorrectFor(String callBackName, int expectedCount) {
            int count = 0;
        try {
            Map<String, Integer> callBackCountsMap = CallBackCounts.getCallBackCounts();
            count = callBackCountsMap.get(callBackName);
            if (count == expectedCount)
                System.out.println("Test Passed !!");
            else
                System.out.println("Test Failed - Number of call backs to " + callBackName +" method; Expected - " + expectedCount + ", Actual - " + count);
        } catch(NullPointerException ex){
            if (expectedCount == 0)
                System.out.println("Test Passed !!");
            else
                System.out.println("Number of call backs to " + callBackName +" method; Expected - " + expectedCount + ", Actual - " + count);
        }
    }
    
}
